# define the differnt library versions, to make it easier for updates
%define libavcodec 52
%define libavdevice 52
%define libavfilter 1
%define libavformat 52
%define libavutil 50
%define libpostproc 51
%define libswscale 0
%define libavcore 0
%define baseversion 0.6.0

Name:           ffmpeg
Version: %{baseversion}.24796
Release:        1.2
License:        GPL v3
Summary:        A complete solution to record, convert and stream A/V
Group:          Productivity/Multimedia
Source:         %{name}.tar.bz2
# PATCH-MISSING-TAG -- See http://en.opensuse.org/Packaging/Patches
Patch0:         ffmpeg-xvidcore.patch
# PATCH-MISSING-TAG -- See http://en.opensuse.org/Packaging/Patches
Patch1:         ffmpeg-libswscale.patch
BuildRequires:  freetype2-devel
BuildRequires:  imlib2-devel
BuildRequires:  libdc1394
BuildRequires:  libdc1394-devel
BuildRequires:  libfaac-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libogg-devel
BuildRequires:  libtheora-devel
%if 0%{?suse_version} > 1110
BuildRequires:  libva-devel
%endif
BuildRequires:  libvorbis-devel
BuildRequires:  libvpx-devel
BuildRequires:  libx264-devel
BuildRequires:  libxvidcore-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%if 0%{suse_version} > 1100
# schroedinger was added with openSUSE 11.0
BuildRequires:  schroedinger-devel
%endif

%if 0%suse_version >= 1030
BuildRequires:  libdc1394_control12-devel
%endif

%description
FFmpeg is a complete solution to record, convert and
stream audio and video.
It includes libavcodec, the leading audio/video codec library.

%package -n libavcodec%{libavcodec}
Summary:        Shared librarary: ffmpeg/avcodec
Group:          System/Libraries

%description -n libavcodec%{libavcodec}
Shared Library ffmpeg/avcodec; should only be installed by dependencies

%package -n libavfilter%{libavfilter}
Summary:        Shared librarary: ffmpeg/avfilter
Group:          System/Libraries

%description -n libavfilter%{libavfilter}
Shared Library ffmpeg/avfilter; should only be installed by dependencies

%package -n libavdevice%{libavdevice}
Summary:        Shared librarary: ffmpeg/avdevice
Group:          System/Libraries

%description -n libavdevice%{libavdevice}
Shared Library ffmpeg/avdevice; should only be installed by dependencies

%package -n libavformat%{libavformat}
Summary:        Shared librarary: ffmpeg/avformat
Group:          System/Libraries

%description -n libavformat%{libavformat}
Shared Library ffmpeg/avformat; should only be installed by dependencies

%package -n libavutil%{libavutil}
Summary:        Shared librarary: ffmpeg/avutil
Group:          System/Libraries

%description -n libavutil%{libavutil}
Shared Library ffmpeg/avutil; should only be installed by dependencies

%package -n libpostproc%{libpostproc}
Summary:        Shared librarary: ffmpeg/postproc
Group:          System/Libraries

%description -n libpostproc%{libpostproc}
Shared Library ffmpeg/postproc; should only be installed by dependencies

%package -n libavcore%{libavcore}
Summary:        Shared librarary: ffmpeg/avcore
Group:          System/Libraries

%description -n libavcore%{libavcore}
Shared Library ffmpeg/avcore; should only be installed by dependencies

%package -n libswscale%{libswscale}
Summary:        Shared librarary: ffmpeg/swscale
Group:          System/Libraries

%description -n libswscale%{libswscale}
Shared Library ffmpeg/swscale; should only be installed by dependencies

%package -n lib%{name}-devel
Summary:        ffmpeg Headers and library
Group:          Development/Libraries/C and C++
Requires:       faad2-devel
Requires:       libavcodec%{libavcodec}
Requires:       libavdevice%{libavdevice}
Requires:       libavfilter%{libavfilter}
Requires:       libavformat%{libavformat}
Requires:       libavutil%{libavutil}
Requires:       libfaac-devel
Requires:       libmp3lame-devel
Requires:       libogg-devel
Requires:       libpostproc%{libpostproc}
Requires:       libraw1394-devel
Requires:       libswscale%{libswscale}
Requires:       libtheora-devel
Requires:       libx264-devel
Requires:       libxvidcore-devel
Requires:       libavcore%{libavcore}
Obsoletes:      %{name}-devel

%description -n lib%{name}-devel
Development files to link against ffmpeg

%prep
%setup -q -n %{name}
%patch0
%patch1 -p1

%build
# --enable-faac was removed due to licensing issues. It would require turning ffmpeg into the non-free version.
CXXFLAGS+="-fPIC" ./configure \
  --prefix=%{_prefix} \
  --mandir=%{_mandir} \
  --libdir=%{_libdir} \
  --shlibdir=%{_libdir} \
  --enable-pthreads   \
  --enable-shared     \
  --enable-avfilter   \
  --disable-static    \
  --enable-libmp3lame \
  --enable-libxvid    \
  --enable-libx264    \
  --enable-postproc   \
  --enable-shared     \
  --enable-libdc1394  \
  --enable-libtheora  \
%if 0%{suse_version} > 1100
  --enable-libschroedinger \
%endif
  --enable-libvpx \
  --enable-gpl \
  --enable-version3
make %{?jobs:-j %jobs}

%install
%makeinstall

%clean
rm -rf %{buildroot}

%post -n libavcodec%{libavcodec} -p /sbin/ldconfig
%postun -n libavcodec%{libavcodec} -p /sbin/ldconfig

%post -n libavfilter%{libavfilter} -p /sbin/ldconfig
%postun -n libavfilter%{libavfilter} -p /sbin/ldconfig

%post -n libavformat%{libavformat} -p /sbin/ldconfig
%postun -n libavformat%{libavformat} -p /sbin/ldconfig

%post -n libavutil%{libavutil} -p /sbin/ldconfig
%postun -n libavutil%{libavutil} -p /sbin/ldconfig

%post -n libpostproc%{libpostproc} -p /sbin/ldconfig
%postun -n libpostproc%{libpostproc} -p /sbin/ldconfig

%post -n libavdevice%{libavdevice} -p /sbin/ldconfig
%postun -n libavdevice%{libavdevice} -p /sbin/ldconfig

%post -n libswscale%{libswscale} -p /sbin/ldconfig
%postun -n libswscale%{libswscale} -p /sbin/ldconfig

%post -n libavcore%{libavcore} -p /sbin/ldconfig
%postun -n libavcore%{libavcore} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_bindir}/ffmpeg
%{_bindir}/ffprobe
%{_bindir}/ffserver
%{_datadir}/%{name}
%{_mandir}/man1/ffmpeg.1.gz
%{_mandir}/man1/ffprobe.1.gz
%{_mandir}/man1/ffserver.1.gz

%files -n libavcodec%{libavcodec}
%defattr(-,root,root)
%{_libdir}/libavcodec.so.%{libavcodec}*

%files -n libavfilter%{libavfilter}
%defattr(-,root,root)
%{_libdir}/libavfilter.so.%{libavfilter}*

%files -n libavformat%{libavformat}
%defattr(-,root,root)
%{_libdir}/libavformat.so.%{libavformat}*

%files -n libavutil%{libavutil}
%defattr(-,root,root)
%{_libdir}/libavutil.so.%{libavutil}*

%files -n libpostproc%{libpostproc}
%defattr(-,root,root)
%{_libdir}/libpostproc.so.%{libpostproc}*

%files -n libavdevice%{libavdevice}
%defattr(-,root,root)
%{_libdir}/libavdevice.so.%{libavdevice}*

%files -n libswscale%{libswscale}
%defattr(-,root,root)
%{_libdir}/libswscale.so.%{libswscale}*

%files -n libavcore%{libavcore}
%defattr(-, root, root)
%{_libdir}/libavcore.so.%{libavcore}*

%files -n lib%{name}-devel
%defattr(-,root,root)
%{_libdir}/pkgconfig/libavcodec.pc
%{_libdir}/pkgconfig/libavfilter.pc
%{_libdir}/pkgconfig/libavformat.pc
%{_libdir}/pkgconfig/libavutil.pc
%{_libdir}/pkgconfig/libswscale.pc
%{_libdir}/pkgconfig/libavdevice.pc
%{_libdir}/pkgconfig/libavcore.pc
%{_includedir}/libpostproc
%{_includedir}/libavcodec
%{_includedir}/libavfilter
%{_includedir}/libavdevice
%{_includedir}/libavformat
%{_includedir}/libavutil
%{_includedir}/libswscale
%{_includedir}/libavcore
%{_libdir}/pkgconfig/libpostproc.pc
%{_libdir}/libavcodec.so
%{_libdir}/libavfilter.so
%{_libdir}/libavformat.so
%{_libdir}/libavutil.so
%{_libdir}/libpostproc.so
%{_libdir}/libavdevice.so
%{_libdir}/libswscale.so
%{_libdir}/libavcore.so

%changelog
* Sun Jun 20 2010 dominique-vlc.suse@leuenberger.net
- Remove faad2-devel BuildRequires and the --enable-faad2*
  configure switches.
* Wed Jun 16 2010 dominique-vlc.suse@leuenberger.net
- Version bump to 0.6, as there was once more a release.
* Tue Jun  8 2010 dominique-vlc.suse@leuenberger.net
- BuildRequire libva-devel on openSUSE 11.2+
* Mon Jun  7 2010 dominique-vlc.suse@leuenberger.net
- Add libvpx-devel BuildRequires.
* Sun May 16 2010 dominique-vlc.suse@leuenberger.net
- Require and BuildRequire libmp3lame-devel instaed of lame-devel.
* Wed Apr 21 2010 dominique-vlc.suse@leuenberger.net
- Bump base version to 0.5, which will be extended by the svn rev.
* Wed Jul  8 2009 dominique-vlc.suse@leuenberger.net
- Add patch ffmpeg-svn19371-xvidcore-detection.patch to correctly
  link libxvid with --as-needed.
